"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogAxiosErrorInterceptor = void 0;
const common_1 = require("@nestjs/common");
const operators_1 = require("rxjs/operators");
const converter_1 = require("../converter");
const uuid_1 = require("uuid");
let LogAxiosErrorInterceptor = class LogAxiosErrorInterceptor {
    intercept(ctx, next) {
        return next.handle().pipe((0, operators_1.catchError)((error) => {
            if (!(error === null || error === void 0 ? void 0 : error.config))
                throw error;
            if (!(error === null || error === void 0 ? void 0 : error.uuid) && !error.traceId) {
                error.traceId = (0, uuid_1.v4)();
            }
            new common_1.Logger(`${error.traceId || (error === null || error === void 0 ? void 0 : error.uuid)}:`).warn(converter_1.AxiosConverter.getCurl(error));
            throw error;
        }));
    }
};
LogAxiosErrorInterceptor = __decorate([
    (0, common_1.Injectable)()
], LogAxiosErrorInterceptor);
exports.LogAxiosErrorInterceptor = LogAxiosErrorInterceptor;
